/*******************************************************************************
 * Copyright (c) 2003, 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 * Port to the D programming language:
 *      John Reimer <terminal.node@gmail.com>
 *******************************************************************************/
module dwt.browser.HelperAppLauncherDialog;

import dwt.dwthelper.utils;

import Utf = tango.text.convert.Utf;

import dwt.DWT;
//import dwt.internal.C;
import dwt.internal.mozilla.XPCOM;
//import dwt.internal.mozilla.XPCOMObject;
import dwt.internal.mozilla.nsEmbedString;
import dwt.internal.mozilla.nsID;
import dwt.internal.mozilla.nsIHelperAppLauncher;
import dwt.internal.mozilla.nsIHelperAppLauncherDialog;
import dwt.internal.mozilla.nsIHelperAppLauncher_1_8;
import dwt.internal.mozilla.nsIHelperAppLauncher_1_9;
import dwt.internal.mozilla.nsISupports;
import dwt.widgets.FileDialog;
import dwt.widgets.Shell;

class HelperAppLauncherDialog : nsHelperAppLauncherDialog {
    //XPCOMObject supports;
    //XPCOMObject helperAppLauncherDialog;
    int refCount = 0;

this() {
    //createCOMInterfaces ();
}

nsrefcnt AddRef () {
    refCount++;
    return refCount;
}
/+
void createCOMInterfaces () {
    /* Create each of the interfaces that this object implements */
    supports = new XPCOMObject (new int[] {2, 0, 0}) {
        public int /*long*/ method0 (int /*long*/[] args) {return QueryInterface (args[0], args[1]);}
        public int /*long*/ method1 (int /*long*/[] args) {return AddRef ();}
        public int /*long*/ method2 (int /*long*/[] args) {return Release ();}
    };
    
    helperAppLauncherDialog = new XPCOMObject (new int[] {2, 0, 0, 3, 5}) {
        public int /*long*/ method0 (int /*long*/[] args) {return QueryInterface (args[0], args[1]);}
        public int /*long*/ method1 (int /*long*/[] args) {return AddRef ();}
        public int /*long*/ method2 (int /*long*/[] args) {return Release ();}
        public int /*long*/ method3 (int /*long*/[] args) {return Show (args[0], args[1], (int)/*64*/args[2]);}
        public int /*long*/ method4 (int /*long*/[] args) {return PromptForSaveToFile (args[0], args[1], args[2], args[3], args[4]);}
    };      
}

void disposeCOMInterfaces () {
    if (supports !is null) {
        supports.dispose ();
        supports = null;
    }   
    if (helperAppLauncherDialog !is null) {
        helperAppLauncherDialog.dispose ();
        helperAppLauncherDialog = null; 
    }
}

int /*long*/ getAddress () {
    return helperAppLauncherDialog.getAddress ();
}
+/
nsresult QueryInterface (nsID* riid, void** ppvObject) {
    if (riid is null || ppvObject is null) return XPCOM.NS_ERROR_NO_INTERFACE;
    //nsID guid = new nsID ();
    //XPCOM.memmove (guid, riid, nsID.sizeof);
    
    if (*riid == nsISupports.IID) {
        *ppvObject = cast(void*)cast(nsISupports)this;
        AddRef ();
        return XPCOM.NS_OK;
    }
    if (*riid == nsIHelperAppLauncherDialog.IID) {
        *ppvObject = cast(void*)cast(nsIHelperAppLauncherDialog)this;
        AddRef ();
        return XPCOM.NS_OK;
    }
    
    *ppvObject = null;
    return XPCOM.NS_ERROR_NO_INTERFACE;
}
            
nsrefcnt Release () {
    refCount--;
    /*
    * Note.  This instance lives as long as the download it is binded to.
    * Its reference count is expected to go down to 0 when the download
    * has completed or when it has been cancelled. E.g. when the user
    * cancels the File Dialog, cancels or closes the Download Dialog
    * and when the Download Dialog goes away after the download is completed.
    */
    //if (refCount is 0) disposeCOMInterfaces ();
    return refCount;
}

/* nsIHelperAppLauncherDialog */

nsresult Show (nsIHelperAppLauncher aLauncher, nsISupports aContext, PRUint32 aReason) {
    /*
    * The interface for nsIHelperAppLauncher changed in GRE versions 1.8 and 1.9.  Query for
    * each of these interfaces in turn until one is found.
    */
    // FIXME: Not sure if this will work because of different versions of 
    // nsIHelperAppLauncher.  Remember to check. -JJR
    nsIHelperAppLauncher_1_9 helperAppLauncher1;
    int rc = aLauncher.QueryInterface (nsIHelperAppLauncher_1_9.IID, cast(void*)&helperAppLauncher1);
    if (rc is 0) {
       // nsIHelperAppLauncher_1_9 helperAppLauncher = new nsIHelperAppLauncher_1_9 (aLauncher);
        rc = helperAppLauncher1.SaveToDisk (0, 0);
        helperAppLauncher1.Release ();
        return rc;
    }

    //result[0] = 0;
    nsIHelperAppLauncher_1_8 helperAppLauncher2;
    rc = aLauncher.QueryInterface (nsIHelperAppLauncher_1_8.IID, cast(void*)&helperAppLauncher2);
    if (rc is 0) {
        //nsIHelperAppLauncher_1_8 helperAppLauncher = new nsIHelperAppLauncher_1_8 (aLauncher);
        rc = helperAppLauncher2.SaveToDisk (0, 0);
        helperAppLauncher2.Release ();
        return rc;
    }

    //nsIHelperAppLauncher helperAppLauncher = new nsIHelperAppLauncher (aLauncher);  /* < 1.8 */
    return aLauncher.SaveToDisk (0, 0);
}

int PromptForSaveToFile (nsIHelperAppLauncher arg0, nsISupports arg1, PRUnichar* arg2, PRUnichar* arg3, nsILocalFile* arg4) {
    PRUnichar* aDefaultFile;
    PRUnichar* aSuggestedFileExtension;
    nsILocalFile* _retval;
    bool hasLauncher = false;

    /*
    * The interface for nsIHelperAppLauncherDialog changed as of mozilla 1.5 when an
    * extra argument was added to the PromptForSaveToFile method (this resulted in all
    * subsequent arguments shifting right).  The workaround is to provide an XPCOMObject 
    * that fits the newer API, and to use the first argument's type to infer whether
    * the old or new nsIHelperAppLauncherDialog interface is being used (and by extension
    * the ordering of the arguments).  In mozilla >= 1.5 the first argument is an
    * nsIHelperAppLauncher. 
    */
    /*
     * The interface for nsIHelperAppLauncher changed as of mozilla 1.8, so the first
     * argument must be queried for both the old and new nsIHelperAppLauncher interfaces. 
     */
    bool using_1_8 = false, using_1_9 = false;
    // technically this should have an AddRef? -JJR
    nsISupports support = cast(nsISupports)arg0; 
    //int /*long*/[] result = new int /*long*/[1];
    if (arg0 is null)
        assert(0);
        
    nsIHelperAppLauncher_1_8 helperAppLauncher1;
    int rc = support.QueryInterface (nsIHelperAppLauncher_1_8.IID, cast(void*)&helperAppLauncher1);
    if (rc is 0) {
        using_1_8 = true;
        hasLauncher = true;
        helperAppLauncher1.Release ();
    } else {
        nsIHelperAppLauncher_1_9 helperAppLauncher2;
        rc = support.QueryInterface (nsIHelperAppLauncher_1_9.IID, cast(void*)&helperAppLauncher2);
        if (rc is 0) {
            using_1_9 = true;
            hasLauncher = true;
            helperAppLauncher2.Release;
        } else {
            nsIHelperAppLauncher helperAppLauncher;
            rc = support.QueryInterface (nsIHelperAppLauncher.IID, cast(void*)&helperAppLauncher);
            if (rc is 0) {
                hasLauncher = true;
                helperAppLauncher.Release;
            }
        }
    }
    //result[0] = 0;

    if (hasLauncher) {  /* >= 1.5 */
        aDefaultFile = arg2;
        aSuggestedFileExtension = arg3;
        _retval = arg4;
    } else {            /* 1.4 */  
    // This call conversion probablywon't work for non-Java
    // and shouldn't get called; fix it later. -JJR
        aDefaultFile = arg1;
        aSuggestedFileExtension = arg2;
        _retval = arg3;
    }

    int span = XPCOM.strlen_PRUnichar (aDefaultFile);
    // XPCOM.memmove (dest, aDefaultFile, length * 2);
    String defaultFile = Utf.toString (aDefaultFile[0 .. span]));

    span = XPCOM.strlen_PRUnichar (aSuggestedFileExtension);
    //dest = new char[length];
    //XPCOM.memmove (dest, aSuggestedFileExtension, length * 2);
    String suggestedFileExtension =  Utf.toString (aSuggestedFileExtension[0 .. span]);

    Shell shell = new Shell ();
    FileDialog fileDialog = new FileDialog (shell, DWT.SAVE);
    fileDialog.setFileName (defaultFile);
    String[] tmp ~= suggestedFileExtension; 
    fileDialog.setFilterExtensions (tmp);
    String name = fileDialog.open ();
    shell.close ();
    if (name is null) {
        if (hasLauncher) {
            // not sure if these produce correct interface alignment. Check. -JJR
            if (using_1_8) {
                auto launcher = cast(nsIHelperAppLauncher_1_8)cast(void*)arg0;
                rc = launcher.Cancel (XPCOM.NS_BINDING_ABORTED);
            } else if (using_1_9) {
                auto launcher = cast(nsIHelperAppLauncher_1_9)cast(void*)arg0;
                rc = launcher.Cancel (XPCOM.NS_BINDING_ABORTED);
            } else {
                //nsIHelperAppLauncher launcher = new nsIHelperAppLauncher (arg0);
                rc = arg0.Cancel ();
            }
            if (rc !is XPCOM.NS_OK) Mozilla.error (rc);
            return XPCOM.NS_OK;
        }
        return XPCOM.NS_ERROR_FAILURE;
    }
    scope auto path = new nsEmbedString (name);
    nsILocalFile localFile;
    rc = XPCOM.NS_NewLocalFile (cast(nsAString*)path, 1, cast(void*)&localFile);
    //path.dispose ();
    if (rc !is XPCOM.NS_OK) Mozilla.error (rc);
    if (localFile is null) Mozilla.error (XPCOM.NS_ERROR_NULL_POINTER);
    /* Our own nsIDownload has been registered during the Browser initialization. It will be invoked by Mozilla. */
    *_retval = cast(void*)&localFile; 
    //XPCOM.memmove (_retval, result, C.PTR_SIZEOF);  
    return XPCOM.NS_OK;
}
}
